unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.ScrollBox, FMX.Memo, FMX.Controls.Presentation, IdBaseComponent,
  IdComponent, IdCustomTCPServer, IdTCPServer, IdContext,

  // T.b.v. IP adres uitlezen:
  Androidapi.JNIBridge, Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.JavaTypes, Androidapi.Helpers, Androidapi.JNI.NET;

//function Defineren meteen na uses en voor
//type, op deze plek staat meestal nog niets.
  function GetWiFiManager: JWifiManager;
  Function Hex2ToInt(Hex: string): Integer;


type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    IdTCPServer1: TIdTCPServer;
    Label3: TLabel;
    procedure IdTCPServer1Connect(AContext: TIdContext);
    procedure IdTCPServer1Disconnect(AContext: TIdContext);
    procedure IdTCPServer1Execute(AContext: TIdContext);
    procedure IdTCPServer1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure Button1Click(Sender: TObject);
    function  GetNow():String;
    procedure ShowNumberOfClients(p_disconnected : Boolean=False);
    procedure BroadcastMessage(p_message : string);
    procedure Display(p_message : string);
    procedure GetIP;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


Const
  GUEST_CLIENT_PORT = 20010; //Via deze Poort Luisterd deze Server

var
  Form1: TForm1;

implementation

{$R *.fmx}





























//------------------------------------------------------------------------------

procedure TForm1.Button1Click(Sender: TObject);
begin
 IdTCPServer1.Bindings.Clear;

 // ... voeg een poort toe voor verbindingen van gastclients.
 IdTCPServer1.Bindings.Add.Port := GUEST_CLIENT_PORT;  //Via deze Poort Luisterd deze Server

 IdTCPServer1.Active   := True;
 Button1.Enabled := False;  //Start Knop
 Button2.Enabled := True;  //Stop Knop
 Display('Ontvanger Gestart');
 Label3.Text := 'Aantal Zenders: 0';

end;

//------------------------------------------------------------------------------

procedure TForm1.Button2Click(Sender: TObject);
begin
 Label3.Text := 'Aantal Zenders: -';

 BroadcastMessage('Goodbye Client ');
 IdTCPServer1.Active := False;
 Button2.Enabled := False;  //Stop Knop
 Button1.Enabled := True;  //Start Knop
 Display('Ontvanger Gestopt');
 Label3.Text := 'Aantal Zenders: -';

end;

//------------------------------------------------------------------------------

procedure TForm1.Button3Click(Sender: TObject);
begin
 Memo1.Lines.Clear;
end;

//------------------------------------------------------------------------------

procedure TForm1.IdTCPServer1Connect(AContext: TIdContext);
var
 ip          : string;
 port        : Integer;
 peerIP      : string;
 peerPort    : Integer;
 nClients    : Integer;
 msgToClient : string;
 typeClient  : string;

begin
 ip        := AContext.Binding.IP;
 port      := AContext.Binding.Port;
 peerIP    := AContext.Binding.PeerIP;
 peerPort  := AContext.Binding.PeerPort;

 Display('Client Connected');
 Display('>Port: '     + IntToStr(Port));
 Display('>PeerIP: '   + PeerIP);
 Display('>PeerPort: ' + IntToStr(PeerPort));



 ShowNumberOfClients();

 // ... CLIENT CONNECTED:
 case Port of
 GUEST_CLIENT_PORT : begin
                       // ... GUEST CLIENTS
                       typeClient := 'GUEST';
                     end;

 end;

 msgToClient := 'Welcome ' + typeClient + ' ' + 'Client :)';
 AContext.Connection.IOHandler.WriteLn( msgToClient );

end;

//------------------------------------------------------------------------------

procedure TForm1.IdTCPServer1Disconnect(AContext: TIdContext);
var
 ip          : string;
 port        : Integer;
 peerIP      : string;
 peerPort    : Integer;
 nClients    : Integer;

begin

 // ... getting IP address and Port of Client that connected
 ip        := AContext.Binding.IP;
 port      := AContext.Binding.Port;
 peerIP    := AContext.Binding.PeerIP;
 peerPort  := AContext.Binding.PeerPort;

 Display('Client Disconnected');
 Display('>Port: '     + IntToStr(Port));
 Display('>PeerIP: '   + PeerIP);
 Display('>PeerPort: ' + IntToStr(PeerPort));

 ShowNumberOfClients(true);

end;

//------------------------------------------------------------------------------

procedure TForm1.IdTCPServer1Execute(AContext: TIdContext);
var
 Port          : Integer;
 PeerPort      : Integer;
 PeerIP        : string;
 msgFromClient : string;
 msgToClient   : string;

begin
 msgFromClient := AContext.Connection.IOHandler.ReadLn;
 peerIP    := AContext.Binding.PeerIP;
 peerPort  := AContext.Binding.PeerPort;

 //Display( PeerIP); //Het bericht komt van dit IP
 Display( msgFromClient);
 AContext.Connection.IOHandler.WriteLn('... message sent from server :)');

end;

//------------------------------------------------------------------------------

procedure TForm1.IdTCPServer1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: string);
begin
 Sleep(500);
 Application.processmessages;
 Display(AStatusText);

end;

//------------------------------------------------------------------------------

function TForm1.getNow() : String;
begin
 //Result := FormatDateTime('dd-mm-yyyy hh:nn:ss', Now);
 //Result := FormatDateTime('hh:nn:ss', Now) + ': ';
 Result := FormatDateTime('hh:nn', Now);

end;

//------------------------------------------------------------------------------

procedure TForm1.ShowNumberOfClients(p_disconnected : Boolean=False);
var
 nClients : integer;
begin

 try
   // ... get number of clients connected
   nClients := IdTCPServer1.Contexts.LockList.Count;
 finally
   IdTCPServer1.Contexts.UnlockList;
 end;

 // ... client disconnected?
 if p_disconnected then dec(nClients);

 // ... display
 TThread.Queue(nil, procedure
   begin
    Label3.Text := 'Aantal Zenders: ' + IntToStr(nClients);
   end
 );

end;

//------------------------------------------------------------------------------

procedure TForm1.broadcastMessage(p_message : string);
var
 tmpList      : TIdContextList; //   TList;   //Gaf een fout melding;
 contexClient : TidContext;
 nClients     : Integer;
 i            : integer;

begin
  // ... send a message to all clients connected

  // ... get context Locklist
  tmpList  := IdTCPServer1.Contexts.LockList;

  try
    i := 0;
    while ( i < tmpList.Count ) do begin
      // ... get context (thread of i-client)
      contexClient := tmpList[i];

      // ... send message to client
      contexClient.Connection.IOHandler.WriteLn(p_message);
      i := i + 1;
    end;

  finally
    // ... unlock list of clients!
    IdTCPServer1.Contexts.UnlockList;
  end;

end;

//------------------------------------------------------------------------------

procedure TForm1.Display(p_message : string);
begin
 // ... DISPLAY MESSAGE
 TThread.Queue(nil, procedure
   begin
    //Memo1.Lines.Add('[' + p_sender + '] - ' + getNow() + ': ' + p_message);
    Memo1.Lines.Add( getNow() + ': ' + p_message);


   end
 );

end;

//------------------------------------------------------------------------------

procedure TForm1.FormActivate(Sender: TObject);
begin
 Label1.Text := 'Ontvangen';
 Label2.Text := '-';
 Label3.Text := 'Aantal Zenders: -';

 GetIP();
end;

//------------------------------------------------------------------------------

procedure TForm1.GetIP;
var
 WiFiManager: JWifiManager;
 info: JWiFiInfo;
 ip: Integer;
 Hex, Hex1, Hex2, Hex3, Hex4: String;

begin
  WifiManager := GetWiFiManager;
  info := WifiManager.getConnectionInfo;  // <- Crash without exception
  ip := info.getIpAddress;

//Label1.Text := IntToStr(info.getIpAddress);   //Geeft iets van 263366848  (IP adres als Integer)
//Label1.Text := info.getIpAddress.ToHexString; //Geeft iets van 0FB2ABC0   (IP adres als Hex)

  //De Hex splitsen in 4 delen, en deze opzetten naar Integers
  Hex := info.getIpAddress.ToHexString; //0F B2 A8 C0   .ToString; //geeft 263366848      .toString ;
  Hex1 := Copy(Hex,0,2);  //Copy uit 'Hex' vanaf karakter 0, de eerste 2 tekens
  Hex2 := Copy(Hex,3,2);  //Copy uit 'Hex' vanaf karakter 2, de eerste 2 tekens
  Hex3 := Copy(Hex,5,2);  //Copy uit 'Hex' vanaf karakter 4, de eerste 2 tekens
  Hex4 := Copy(Hex,7,2);  //Copy uit 'Hex' vanaf karakter 6, de eerste 2 tekens

  Label2.Text := IntToStr( Hex2ToInt(Hex4)) + '.' + IntToStr( Hex2ToInt(Hex3)) + '.' + IntToStr( Hex2ToInt(Hex2)) + '.' + IntToStr( Hex2ToInt(Hex1));

end;

//------------------------------------------------------------------------------

function GetWiFiManager: JWifiManager;
var ConnectivityServiceNative: JObject;
begin
  ConnectivityServiceNative := SharedActivityContext.getSystemService(TJContext.JavaClass.WIFI_SERVICE);
  if not Assigned(ConnectivityServiceNative) then
    raise Exception.Create('Could not locate Connectivity Service');
  Result := TJWifiManager.Wrap(
    (ConnectivityServiceNative as ILocalObject).GetObjectID);
  if not Assigned(Result) then
    raise Exception.Create('Could not access Connectivity Manager');
end;

//------------------------------------------------------------------------------

Function Hex2ToInt(Hex: string): Integer;
Var
 Hex1, Hex2: Char;
 Uitkomst: Integer;

begin

  if Length(Hex) <> 2 then
   begin
    //De Hex bevat geen 2 Karr.
    Result := -1;
    exit
   end;

  Hex1 := Hex[1];  //Het Rechtse Karr.
  Hex2 := Hex[0];  //Het linkse Karr.

  Uitkomst := 0;

  case Hex1 of
   '0'..'9': Uitkomst := StrToInt(Hex1);
   'a': Uitkomst := 10;
   'A': Uitkomst := 10;
   'b': Uitkomst := 11;
   'B': Uitkomst := 11;
   'c': Uitkomst := 12;
   'C': Uitkomst := 12;
   'd': Uitkomst := 13;
   'D': Uitkomst := 13;
   'e': Uitkomst := 14;
   'E': Uitkomst := 14;
   'f': Uitkomst := 15;
   'F': Uitkomst := 15;
  end;

  case Hex2 of
   '0'..'9': Uitkomst := Uitkomst + StrToInt(Hex2) * 16;
   'a': Uitkomst := Uitkomst + 160;
   'A': Uitkomst := Uitkomst + 160;
   'b': Uitkomst := Uitkomst + 176;
   'B': Uitkomst := Uitkomst + 176;
   'c': Uitkomst := Uitkomst + 192;
   'C': Uitkomst := Uitkomst + 192;
   'd': Uitkomst := Uitkomst + 208;
   'D': Uitkomst := Uitkomst + 208;
   'e': Uitkomst := Uitkomst + 224;
   'E': Uitkomst := Uitkomst + 224;
   'f': Uitkomst := Uitkomst + 240;
   'F': Uitkomst := Uitkomst + 240;
  end;

  Result := Uitkomst;

end;

//------------------------------------------------------------------------------



end.
